/*
For information on this software or to report bugs please visit http://www.ranton.org
or email ranton@ranton.org

For custom software development and consulting please visit http://www.madlogic.com .

Copyright (c) 2006, Richard Neal Anton
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

*	Redistributions of source code must retain the above copyright notice, this list
	of conditions and the following disclaimer. 

*	Redistributions in binary form must reproduce the above copyright notice, this list
	of conditions and the following disclaimer in the documentation and/or other materials
	provided with the distribution. 

*	The name of the copyright holder may not be used to endorse or promote products 
	derived from this software without specific prior written permission. 

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT
SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#define RCI_INTERNAL
#ifndef __RCI__
#include "rci.h"
#endif

int RciRead8(int fd, RciUns8 *out)
{
	int ret = RciRead(fd,out,1);
	return ret;
}

int RciRead16BE(int fd, RciUns16 *out)
{
	RciUns8 buf[2];
	int ret = RciRead(fd,buf,2);
	if( ret == 0 )
	{
		*out = buf[0];
		*out <<= 8;
		*out |= buf[1];
	}
	return ret;
}

int RciRead32BE(int fd, RciUns32 *out)
{
	int ret;
	RciUns8 buf[4];
	ret = RciRead(fd,buf,4);
	if( ret == 0 )
	{
		*out = buf[0];
		*out <<= 8;
		*out |= buf[1];
		*out <<= 8;
		*out |= buf[2];
		*out <<= 8;
		*out |= buf[3];
	}
	return ret;
}

int RciWrite8(int fd, RciUns8 in)
{
	return RciWrite(fd,&in,1);
}

int RciWrite16BE(int fd, RciUns16 in)
{
	RciUns8 buf[2];

	buf[1] = in&0xFF;
	in >>= 8;
	buf[0] = in&0xFF;

	return RciWrite(fd,buf,2);
}

int RciWrite32BE(int fd, RciUns32 in)
{
	RciUns8 buf[4];

	buf[3] = (RciUns8)(in&0xFF);
	in >>= 8;
	buf[2] = (RciUns8)(in&0xFF);
	in >>=8;
	buf[1] = (RciUns8)(in&0xFF);
	in >>= 8;
	buf[0] = (RciUns8)(in&0xFF);

	return RciWrite(fd,buf,4);
}

